### Hierarchy

- ComboBox

### Implements

- OnChanges
- AfterViewInit
- AfterContentInit
- OnDestroy

## Index

### Inputs

- appendInline
- autocomplete
- disabled
- dropUp
- helperText
- id
- invalid
- invalidText
- itemValueKey
- items
- label
- maxLength
- selectionFeedback
- size
- theme
- type
- warn
- warnText
- clearSelectionAria
- clearSelectionTitle
- clearSelectionsAria
- clearSelectionsTitle
- closeMenuAria
- openMenuAria
- placeholder

### Outputs

- close
- search
- selected
- submit

### Constructors

- constructor

### Properties

- _clearSelectionAria
- _clearSelectionTitle
- _clearSelectionsAria
- _clearSelectionsTitle
- _closeMenuAria
- _dropUp
- _openMenuAria
- _placeholder
- appendInline
- autocomplete
- close
- disabled
- display
- documentService
- dropUp
- dropdownMenu
- dropdownService
- elementRef
- helperText
- hostClass
- i18n
- id
- input
- invalid
- invalidText
- itemValueKey
- items
- keyboardNav
- label
- listbox
- maxLength
- noop
- onTouchedCallback
- open
- pills
- propagateChangeCallback
- search
- selected
- selectedValue
- selectionFeedback
- showClearButton
- size
- submit
- theme
- type
- view
- warn
- warnText
- comboBoxCount

### Accessors

- clearSelectionAria
- clearSelectionTitle
- clearSelectionsAria
- clearSelectionsTitle
- closeMenuAria
- openMenuAria
- placeholder

### Methods

- _appendToBody
- _appendToDropdown
- _keyboardNav
- _noop
- _shouldDropUp
- checkForReorder
- clearInput
- clearSelected
- closeDropdown
- hostkeys
- isTemplate
- ngAfterContentInit
- ngAfterViewInit
- ngOnChanges
- ngOnDestroy
- onBlur
- onSearch
- onSubmit
- openDropdown
- registerOnChange
- registerOnTouched
- setDisabledState
- toggleDropdown
- updatePills
- updateSelected
- writeValue

## Constructors

### constructor

- new ComboBox(elementRef: ElementRef, documentService: DocumentService, dropdownService: DropdownService, i18n: I18n): ComboBox

- - Defined in src/combobox/combobox.component.ts:442

  #### Parameters

  - ##### elementRef: ElementRef

  - ##### documentService: DocumentService

  - ##### dropdownService: DropdownService

  - ##### i18n: I18n

  #### Returns ComboBox

## Properties

### Protected _clearSelectionAria

_clearSelectionAria: Overridable = this.i18n.getOverridable("COMBOBOX.A11Y.CLEAR_SELECTED")

- Defined in src/combobox/combobox.component.ts:442

### Protected _clearSelectionTitle

_clearSelectionTitle: Overridable = this.i18n.getOverridable("COMBOBOX.CLEAR_SELECTED")

- Defined in src/combobox/combobox.component.ts:441

### Protected _clearSelectionsAria

_clearSelectionsAria: Overridable = this.i18n.getOverridable("COMBOBOX.A11Y.CLEAR_SELECTIONS")

- Defined in src/combobox/combobox.component.ts:440

### Protected _clearSelectionsTitle

_clearSelectionsTitle: Overridable = this.i18n.getOverridable("COMBOBOX.CLEAR_SELECTIONS")

- Defined in src/combobox/combobox.component.ts:439

### Protected _closeMenuAria

_closeMenuAria: Overridable = this.i18n.getOverridable("COMBOBOX.A11Y.CLOSE_MENU")

- Defined in src/combobox/combobox.component.ts:437

### _dropUp

_dropUp: boolean = false

- Defined in src/combobox/combobox.component.ts:430

### Protected _openMenuAria

_openMenuAria: Overridable = this.i18n.getOverridable("COMBOBOX.A11Y.OPEN_MENU")

- Defined in src/combobox/combobox.component.ts:438

### Protected _placeholder

_placeholder: Overridable = this.i18n.getOverridable("COMBOBOX.PLACEHOLDER")

- Defined in src/combobox/combobox.component.ts:436

### appendInline

@Input()
appendInline: boolean = null

- Defined in src/combobox/combobox.component.ts:309

### autocomplete

@Input()
autocomplete: string = "list"

- Defined in src/combobox/combobox.component.ts:345

### close

@Output()
close: EventEmitter<void> = new EventEmitter<void>()

- Defined in src/combobox/combobox.component.ts:401

### disabled

@Input()
disabled: boolean = false

- Defined in src/combobox/combobox.component.ts:353

### display

@HostBinding({"hostPropertyName":"style.display"})
display: string = "block"

- Defined in src/combobox/combobox.component.ts:415

### Protected documentService

documentService: DocumentService

- Defined in src/combobox/combobox.component.ts:449

### dropUp

@Input()
dropUp: boolean

- Defined in src/combobox/combobox.component.ts:349

### dropdownMenu

@ViewChild({"selector":"dropdownMenu","opts":"{ static: false }"})
dropdownMenu: any

- Defined in src/combobox/combobox.component.ts:408

### Protected dropdownService

dropdownService: DropdownService

- Defined in src/combobox/combobox.component.ts:450

### Protected elementRef

elementRef: ElementRef

- Defined in src/combobox/combobox.component.ts:448

### helperText

@Input()
helperText: string | TemplateRef<any>

- Defined in src/combobox/combobox.component.ts:305

### hostClass

@HostBinding({"hostPropertyName":"class.bx--list-box__wrapper"})
hostClass: boolean = true

- Defined in src/combobox/combobox.component.ts:413

### Protected i18n

i18n: I18n

- Defined in src/combobox/combobox.component.ts:451

### id

@Input()
id: string = `dropdown-${ComboBox.comboBoxCount++}`

- Defined in src/combobox/combobox.component.ts:256

### input

@ViewChild({"selector":"input","opts":"{ static: true }"})
input: ElementRef

- Defined in src/combobox/combobox.component.ts:410

### invalid

@Input()
invalid: boolean = false

- Defined in src/combobox/combobox.component.ts:313

### invalidText

@Input()
invalidText: string | TemplateRef<any>

- Defined in src/combobox/combobox.component.ts:317

### itemValueKey

@Input()
itemValueKey: string

- Defined in src/combobox/combobox.component.ts:297

### items

@Input()
items: Array<ListItem> = []

- Defined in src/combobox/combobox.component.ts:283

### keyboardNav

keyboardNav: any = this._keyboardNav.bind(this)

- Defined in src/combobox/combobox.component.ts:426

### label

@Input()
label: string | TemplateRef<any>

- Defined in src/combobox/combobox.component.ts:301

### listbox

@ViewChild({"selector":"listbox","opts":"{ static: true }"})
listbox: ElementRef

- Defined in src/combobox/combobox.component.ts:412

### maxLength

@Input()
maxLength: number = null

- Defined in src/combobox/combobox.component.ts:329

### Protected noop

noop: any = this._noop.bind(this)

- Defined in src/combobox/combobox.component.ts:432

### Protected onTouchedCallback

onTouchedCallback: function = this._noop

- Defined in src/combobox/combobox.component.ts:433

#### Type declaration

- - (): void

  - #### Returns void

### open

open: boolean = false

- Defined in src/combobox/combobox.component.ts:417

### pills

pills: any[] = []

- Defined in src/combobox/combobox.component.ts:422

### Protected propagateChangeCallback

propagateChangeCallback: function = this._noop

- Defined in src/combobox/combobox.component.ts:434

#### Type declaration

- - (_: any): void

  - #### Parameters

    - ##### _: any

    #### Returns void

### search

@Output()
search: EventEmitter<string> = new EventEmitter<string>()

- Defined in src/combobox/combobox.component.ts:403

### selected

@Output()
selected: EventEmitter<ListItem | ListItem[]> = new EventEmitter<ListItem | ListItem[]>()

- Defined in src/combobox/combobox.component.ts:365

### selectedValue

selectedValue: string = ""

- Defined in src/combobox/combobox.component.ts:424

### selectionFeedback

@Input()
selectionFeedback: "top" | "fixed" | "top-after-reopen" = "top-after-reopen"

- Defined in src/combobox/combobox.component.ts:340

### showClearButton

showClearButton: boolean = false

- Defined in src/combobox/combobox.component.ts:419

### size

@Input()
size: "sm" | "md" | "xl" = "md"

- Defined in src/combobox/combobox.component.ts:293

### submit

@Output()
submit: EventEmitter<object> = new EventEmitter <{items: ListItem[],index: number,value: {content: string,selected: boolean}}>()

- Defined in src/combobox/combobox.component.ts:392

### theme

@Input()
theme: "light" | "dark" = "dark"

- Defined in src/combobox/combobox.component.ts:333

### type

@Input()
type: "single" | "multi" = "single"

- Defined in src/combobox/combobox.component.ts:287

### view

@ContentChild({"selector":"AbstractDropdownView","opts":"{ static: true }"})
view: AbstractDropdownView

- Defined in src/combobox/combobox.component.ts:406

### warn

@Input()
warn: boolean = false

- Defined in src/combobox/combobox.component.ts:321

### warnText

@Input()
warnText: string | TemplateRef<any>

- Defined in src/combobox/combobox.component.ts:325

### Static comboBoxCount

comboBoxCount: number = 0

- Defined in src/combobox/combobox.component.ts:255

## Accessors

### clearSelectionAria

@Input()
clearSelectionAria:

- Defined in src/combobox/combobox.component.ts:248
- Defined in src/combobox/combobox.component.ts:252

### clearSelectionTitle

@Input()
clearSelectionTitle:

- Defined in src/combobox/combobox.component.ts:238
- Defined in src/combobox/combobox.component.ts:242

### clearSelectionsAria

@Input()
clearSelectionsAria:

- Defined in src/combobox/combobox.component.ts:228
- Defined in src/combobox/combobox.component.ts:232

### clearSelectionsTitle

@Input()
clearSelectionsTitle:

- Defined in src/combobox/combobox.component.ts:218
- Defined in src/combobox/combobox.component.ts:222

### closeMenuAria

@Input()
closeMenuAria:

- Defined in src/combobox/combobox.component.ts:208
- Defined in src/combobox/combobox.component.ts:212

### openMenuAria

@Input()
openMenuAria:

- Defined in src/combobox/combobox.component.ts:198
- Defined in src/combobox/combobox.component.ts:202

### placeholder

@Input()
placeholder:

- Defined in src/combobox/combobox.component.ts:188
- Defined in src/combobox/combobox.component.ts:192

## Methods

### _appendToBody

- _appendToBody(): void

- - Defined in src/combobox/combobox.component.ts:815

  #### Returns void

### _appendToDropdown

- _appendToDropdown(): void

- - Defined in src/combobox/combobox.component.ts:826

  #### Returns void

### _keyboardNav

- _keyboardNav(event: KeyboardEvent): void

- - Defined in src/combobox/combobox.component.ts:794

  #### Parameters

  - ##### event: KeyboardEvent

  #### Returns void

### _noop

- _noop(): void

- - Defined in src/combobox/combobox.component.ts:599

  #### Returns void

### _shouldDropUp

- _shouldDropUp(): boolean

- - Defined in src/combobox/combobox.component.ts:835

  #### Returns boolean

### Protected checkForReorder

- checkForReorder(): void

- - Defined in src/combobox/combobox.component.ts:864

  #### Returns void

### clearInput

- clearInput(event: any): void

- - Defined in src/combobox/combobox.component.ts:770

  #### Parameters

  - ##### event: any

  #### Returns void

### clearSelected

- clearSelected(): void

- - Defined in src/combobox/combobox.component.ts:665

  #### Returns void

### closeDropdown

- closeDropdown(): void

- - Defined in src/combobox/combobox.component.ts:684

  #### Returns void

### hostkeys

@HostListener({"eventName":"keydown","args":"[$event]"})

- hostkeys(ev: KeyboardEvent): void

- - Defined in src/combobox/combobox.component.ts:574

  #### Parameters

  - ##### ev: KeyboardEvent

  #### Returns void

### isTemplate

- isTemplate(value: any): boolean

- - Defined in src/combobox/combobox.component.ts:787

  #### Parameters

  - ##### value: any

  #### Returns boolean

### ngAfterContentInit

- ngAfterContentInit(): void

- - Defined in src/combobox/combobox.component.ts:475

  #### Returns void

### ngAfterViewInit

- ngAfterViewInit(): void

- - Defined in src/combobox/combobox.component.ts:540

  #### Returns void

### ngOnChanges

- ngOnChanges(changes: any): void

- - Defined in src/combobox/combobox.component.ts:459

  #### Parameters

  - ##### changes: any

  #### Returns void

### ngOnDestroy

- ngOnDestroy(): void

- - Defined in src/combobox/combobox.component.ts:564

  #### Returns void

### onBlur

- onBlur(): void

- - Defined in src/combobox/combobox.component.ts:636

  #### Returns void

### onSearch

- onSearch(searchString: any, shouldEmitSearch?: boolean): void

- - Defined in src/combobox/combobox.component.ts:728

  #### Parameters

  - ##### searchString: any

  - ##### Default value shouldEmitSearch: boolean = true

  #### Returns void

### onSubmit

- onSubmit(event: KeyboardEvent): void

- - Defined in src/combobox/combobox.component.ts:759

  #### Parameters

  - ##### event: KeyboardEvent

  #### Returns void

### openDropdown

- openDropdown(): void

- - Defined in src/combobox/combobox.component.ts:696

  #### Returns void

### registerOnChange

- registerOnChange(fn: any): void

- - Defined in src/combobox/combobox.component.ts:640

  #### Parameters

  - ##### fn: any

  #### Returns void

### registerOnTouched

- registerOnTouched(fn: any): void

- - Defined in src/combobox/combobox.component.ts:644

  #### Parameters

  - ##### fn: any

  #### Returns void

### setDisabledState

- setDisabledState(isDisabled: boolean): void

- - Defined in src/combobox/combobox.component.ts:653

  #### Parameters

  - ##### isDisabled: boolean

  #### Returns void

### toggleDropdown

- toggleDropdown(): void

- - Defined in src/combobox/combobox.component.ts:717

  #### Returns void

### updatePills

- updatePills(): void

- - Defined in src/combobox/combobox.component.ts:660

  #### Returns void

### Protected updateSelected

- updateSelected(): void

- - Defined in src/combobox/combobox.component.ts:852

  #### Returns void

### writeValue

- writeValue(value: any): void

- - Defined in src/combobox/combobox.component.ts:604

  #### Parameters

  - ##### value: any

  #### Returns void

Generated using TypeDoc